package chess4j;

public enum Color {
	BLACK(0),
	WHITE(1);
	
	private int color;
	
	private Color(int color) {
		this.color=color;
	}
	
	public int getColor() {
		return color;
	}
	
	public static Color swap(Color c) {
		return c.getColor()==0?WHITE:BLACK;
	}
	
	public boolean equals(Color c) {
		if (c==null) return false;
		return c.getColor()==color;
	}
	
	public boolean isBlack() {
		return color==0;
	}
	
	public boolean isWhite() {
		return color==1;
	}
	
	public String toString() {
		if (color==BLACK.getColor())
			return "black";
		else
			return "white";
	}
}
