package chess4j.board.directions;

import java.util.Collections;
import java.util.HashSet;
import java.util.Set;

public class PieceDirections {

	private static Set<Direction> bishopDirections = new HashSet<Direction>();
	private static Set<Direction> queenDirections = new HashSet<Direction>();
	private static Set<Direction> rookDirections = new HashSet<Direction>();
	
	static {
		bishopDirections.add(NorthEast.getInstance());
		bishopDirections.add(SouthEast.getInstance());
		bishopDirections.add(SouthWest.getInstance());
		bishopDirections.add(NorthWest.getInstance());
		
		rookDirections.add(North.getInstance());
		rookDirections.add(East.getInstance());
		rookDirections.add(South.getInstance());
		rookDirections.add(West.getInstance());
		
		queenDirections.add(North.getInstance());
		queenDirections.add(NorthEast.getInstance());
		queenDirections.add(East.getInstance());
		queenDirections.add(SouthEast.getInstance());
		queenDirections.add(South.getInstance());
		queenDirections.add(SouthWest.getInstance());
		queenDirections.add(West.getInstance());
		queenDirections.add(NorthWest.getInstance());
	}
	
	public static Set<Direction> getBishopDirections() {
		return Collections.unmodifiableSet(bishopDirections);
	}
	
	public static Set<Direction> getQueenDirections() {
		return Collections.unmodifiableSet(queenDirections);
	}
	
	public static Set<Direction> getRookDirections() {
		return Collections.unmodifiableSet(rookDirections);
	}
}
