package chess4j.utils;

import java.util.List;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import chess4j.board.Board;
import chess4j.moves.Move;
import chess4j.moves.MoveGen;

public class MoveUtils {
	private static final Log logger = LogFactory.getLog(MoveUtils.class);
	
	public static void putMoveAtTop(List<Move> moves,Move m) {
		if (moves.remove(m)) {
			moves.add(0, m);
		}
	}
	
	public static boolean isLineValid(List<Move> moveLine,Board board) {
		Board b = board.deepCopy();
		
		for (Move move : moveLine) {
			if (!isLegalMove(move,b)) {
				logger.debug("# invalid line!");
				return false;
			}
			b.applyMove(move);
		}
		
		return true;
	}
	
	public static boolean isLegalMove(Move move,Board board) {
		List<Move> legalMoves = MoveGen.genLegalMoves(board);
		return legalMoves.contains(move);
	}
}
