package chess4j.utils;

import java.util.List;

import chess4j.board.Board;
import chess4j.moves.Move;
import chess4j.moves.MoveGen;

public class Perft {
	
/*	Initial position
    Depth 	Perft(Depth) 	Total Nodes
    1 	20 	20
	2 	400 	420
	3 	8,902 	9322
	4 	197,281 	206,603
	5 	4,865,609 	5,072,212
	6 	119,060,324 	124,132,536
	7 	3,195,901,860 	3,320,034,396
*/
	
/*	r3k2r/p1ppqpb1/bn2pnp1/3PN3/1p2P3/2N2Q1p/PPPBBPPP/R3K2R w KQkq -
    Depth 	Perft(Depth) 	Total Nodes
	1 	48 	48
	2 	2039 	2087
	3 	97,862 	99,949
	4 	4,085,603 	4,185,552
	5 	193,690,690 	197,876,242
	6 	8,031,647,685
	Note: this exceeds 32 bits 	8,229,523,927	
*/	
	public static long perft(Board b,int depth) {
		if (depth <= 0)
			return 1;

		List<Move> moves = MoveGen.genLegalMoves(b);
		long n=1;

		for (Move m : moves) {
			b.applyMove(m);
			n += perft(b,depth-1);
			b.undoLastMove();
		}

		return n;
	}

}
