package chess4j.board;

import java.util.Set;

import junit.framework.Assert;

import org.junit.Test;

public class KingSquaresTest {

	@Test
	public void testFromH1() {
		Set<Square> squares = KingSquares.getSquares(Square.valueOf(File.FILE_H, Rank.RANK_1));
		Assert.assertEquals(3, squares.size());
		Assert.assertTrue(squares.contains(Square.valueOf(File.FILE_G, Rank.RANK_1)));
		Assert.assertTrue(squares.contains(Square.valueOf(File.FILE_G, Rank.RANK_2)));
		Assert.assertTrue(squares.contains(Square.valueOf(File.FILE_H, Rank.RANK_2)));
	}
	
	@Test
	public void testFromD5() {
		Set<Square> squares = KingSquares.getSquares(Square.valueOf(File.FILE_D, Rank.RANK_5));
		Assert.assertEquals(8, squares.size());
		Assert.assertTrue(squares.contains(Square.valueOf(File.FILE_D, Rank.RANK_6)));
		Assert.assertTrue(squares.contains(Square.valueOf(File.FILE_E, Rank.RANK_6)));
		Assert.assertTrue(squares.contains(Square.valueOf(File.FILE_E, Rank.RANK_5)));
		Assert.assertTrue(squares.contains(Square.valueOf(File.FILE_E, Rank.RANK_4)));
		Assert.assertTrue(squares.contains(Square.valueOf(File.FILE_D, Rank.RANK_4)));
		Assert.assertTrue(squares.contains(Square.valueOf(File.FILE_C, Rank.RANK_4)));
		Assert.assertTrue(squares.contains(Square.valueOf(File.FILE_C, Rank.RANK_5)));
		Assert.assertTrue(squares.contains(Square.valueOf(File.FILE_C, Rank.RANK_6)));
	}
	
	@Test
	public void testFromE8() {
		Set<Square> squares = KingSquares.getSquares(Square.valueOf(File.FILE_E, Rank.RANK_8));
		Assert.assertEquals(5, squares.size());
		Assert.assertTrue(squares.contains(Square.valueOf(File.FILE_F, Rank.RANK_8)));
		Assert.assertTrue(squares.contains(Square.valueOf(File.FILE_F, Rank.RANK_7)));
		Assert.assertTrue(squares.contains(Square.valueOf(File.FILE_E, Rank.RANK_7)));
		Assert.assertTrue(squares.contains(Square.valueOf(File.FILE_D, Rank.RANK_7)));
		Assert.assertTrue(squares.contains(Square.valueOf(File.FILE_D, Rank.RANK_8)));
	}
}
