package chess4j.board;

import java.util.Set;

import junit.framework.Assert;

import org.junit.Test;

public class KnightSquaresTest {

	@Test
	public void testFromD3() {
		Set<Square> squares = KnightSquares.getSquares(Square.valueOf(File.FILE_D, Rank.RANK_3));
		Assert.assertEquals(8, squares.size());
		Assert.assertTrue(squares.contains(Square.valueOf(File.FILE_E, Rank.RANK_5)));
		Assert.assertTrue(squares.contains(Square.valueOf(File.FILE_F, Rank.RANK_4)));
		Assert.assertTrue(squares.contains(Square.valueOf(File.FILE_F, Rank.RANK_2)));
		Assert.assertTrue(squares.contains(Square.valueOf(File.FILE_E, Rank.RANK_1)));
		Assert.assertTrue(squares.contains(Square.valueOf(File.FILE_C, Rank.RANK_1)));
		Assert.assertTrue(squares.contains(Square.valueOf(File.FILE_B, Rank.RANK_2)));
		Assert.assertTrue(squares.contains(Square.valueOf(File.FILE_B, Rank.RANK_4)));
		Assert.assertTrue(squares.contains(Square.valueOf(File.FILE_C, Rank.RANK_5)));
	}
	
	@Test
	public void testFromA1() {
		Set<Square> squares = KnightSquares.getSquares(Square.valueOf(File.FILE_A, Rank.RANK_1));
		Assert.assertEquals(2, squares.size());
		Assert.assertTrue(squares.contains(Square.valueOf(File.FILE_B, Rank.RANK_3)));
		Assert.assertTrue(squares.contains(Square.valueOf(File.FILE_C, Rank.RANK_2)));
	}
	
	@Test
	public void testFromG7() {
		Set<Square> squares = KnightSquares.getSquares(Square.valueOf(File.FILE_G, Rank.RANK_7));
		Assert.assertEquals(4, squares.size());
		Assert.assertTrue(squares.contains(Square.valueOf(File.FILE_H, Rank.RANK_5)));
		Assert.assertTrue(squares.contains(Square.valueOf(File.FILE_F, Rank.RANK_5)));
		Assert.assertTrue(squares.contains(Square.valueOf(File.FILE_E, Rank.RANK_6)));
		Assert.assertTrue(squares.contains(Square.valueOf(File.FILE_E, Rank.RANK_8)));
	}
}
