package chess4j.board.directions;

import java.util.Set;

import junit.framework.Assert;

import org.junit.Test;

public class PieceDirectionsTest {

	@Test
	public void testBishopDirections() {
		Set<Direction> dirs = PieceDirections.getBishopDirections();
		Assert.assertEquals(4, dirs.size());
		Assert.assertTrue(dirs.contains(NorthEast.getInstance()));
		Assert.assertTrue(dirs.contains(SouthEast.getInstance()));
		Assert.assertTrue(dirs.contains(SouthWest.getInstance()));
		Assert.assertTrue(dirs.contains(NorthWest.getInstance()));
	}
	
	@Test
	public void testRookDirections() {
		Set<Direction> dirs = PieceDirections.getRookDirections();
		Assert.assertEquals(4, dirs.size());
		Assert.assertTrue(dirs.contains(North.getInstance()));
		Assert.assertTrue(dirs.contains(East.getInstance()));
		Assert.assertTrue(dirs.contains(South.getInstance()));
		Assert.assertTrue(dirs.contains(West.getInstance()));
	}

	@Test
	public void testQueenDirections() {
		Set<Direction> dirs = PieceDirections.getQueenDirections();
		Assert.assertEquals(8, dirs.size());
		Assert.assertTrue(dirs.contains(North.getInstance()));
		Assert.assertTrue(dirs.contains(NorthEast.getInstance()));
		Assert.assertTrue(dirs.contains(East.getInstance()));
		Assert.assertTrue(dirs.contains(SouthEast.getInstance()));
		Assert.assertTrue(dirs.contains(South.getInstance()));
		Assert.assertTrue(dirs.contains(SouthWest.getInstance()));
		Assert.assertTrue(dirs.contains(West.getInstance()));
		Assert.assertTrue(dirs.contains(NorthWest.getInstance()));
	}

}
