package chess4j.eval;

import junit.framework.Assert;

import org.junit.Test;

import chess4j.board.Board;
import chess4j.io.FenParser;

public class EvalTest {

	Board board = Board.INSTANCE;

	@Test
	public void testStartPosIs0() {
		board.resetBoard();
		int eval = Eval.eval(board);
		Assert.assertEquals(0, eval);
	}
	
	@Test
	public void testScore1() throws Exception {
		FenParser.setPos(board, "rnbqkbnr/pppppppp/8/8/4P3/8/PPPP1PPP/RNBQKBNR b KQkq e3 0 1");
		int eval = Eval.eval(board);
		Assert.assertEquals(-10, eval);
	}
	
	@Test
	public void testScore2() throws Exception {
		FenParser.setPos(board, "rnbqkbnr/pp1ppppp/2p5/8/4P3/8/PPPP1PPP/RNBQKBNR w KQkq - 0 1");
		int eval = Eval.eval(board);
		Assert.assertEquals(7, eval);
	}

	@Test
	public void testSymmetry() throws Exception {
		FenParser.setPos(board, "7r/R6p/2K4P/5k1P/2p4n/5p2/8/8 w - - 0 1");
		int eval = Eval.eval(board);
		board.flipVertical();
		int eval2 = Eval.eval(board);
		Assert.assertEquals(eval, eval2);
	}

	@Test
	public void testSymmetry2() throws Exception {
		FenParser.setPos(board, "8/k3Nr2/2rR4/1P1n4/6p1/1K6/8/6n1 w - - 0 1");
		int eval = Eval.eval(board);
		board.flipVertical();
		int eval2 = Eval.eval(board);
		Assert.assertEquals(eval, eval2);
	}

}
