package chess4j;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.text.ParseException;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import groovy.lang.MissingMethodException;

import chess4j.exceptions.IllegalMoveException;
import chess4j.io.InputParser;

public final class App {
	private static final Log logger = LogFactory.getLog(App.class);

	private App() { }
	
	/**
	 * @param args
	 */
	public static void main(String[] args) throws Exception {
		logger.info("Welcome to chess4j!\n\n");

		BufferedReader bin = new BufferedReader(new InputStreamReader(System.in));
		String input = "";
		while (true) {
			input = bin.readLine();
			try {
				InputParser.getInstance().parseCommand(input);
			} catch (IllegalMoveException ime) {
				logger.error("Illegal move");
			} catch (ParseException pe) {
				logger.error("Illegal move");
			} catch (MissingMethodException me) {
				logger.error("Error (unknown command): " + input);
			} catch (Exception e) {
				e.printStackTrace();
				logger.debug("caught exception: " + e.getMessage());
			}
		}
	}

}
