package chess4j.board;

import java.util.Collections;
import java.util.HashSet;
import java.util.Set;

import chess4j.moves.Move;




public class Undo {

	private Move move;
	private int fiftyCounter;
	private Set<CastlingRights> castlingRights = new HashSet<CastlingRights>();
	private Square epSquare;
	
	public Undo(Move move,int fiftyCounter,Set<CastlingRights> castlingRights,Square epSquare) {
		this.move=move;
		this.fiftyCounter=fiftyCounter;
		this.castlingRights.addAll(castlingRights);
		this.epSquare=epSquare;
	}

	public Set<CastlingRights> getCastlingRights() {
		return Collections.unmodifiableSet(castlingRights);
	}

	public Square getEpSquare() {
		return epSquare;
	}

	public int getFiftyCounter() {
		return fiftyCounter;
	}

	public Move getMove() {
		return move;
	}
	
	@Override
	public boolean equals(Object obj) {
		if (!(obj instanceof Undo)) {
			return false;
		}
		
		Undo that = (Undo)obj;
		if (!this.getMove().equals(that.getMove())) return false;
		if (this.getFiftyCounter() != that.getFiftyCounter()) return false;
		if (!this.getCastlingRights().equals(that.getCastlingRights())) return false;
		if (this.getEpSquare()==null) {
			if (that.getEpSquare()!=null) return false;
		} else {
			if (!this.getEpSquare().equals(that.getEpSquare())) return false;
		}
		
		return true;
	}
}
