package chess4j.io;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import chess4j.Color;
import chess4j.board.Board;
import chess4j.utils.GameStatus;

public class PrintGameResult {

	private static final Log logger = LogFactory.getLog(PrintGameResult.class);

	public static void printResult(GameStatus gs) {
		Board b = Board.INSTANCE;
		if (GameStatus.CHECKMATED.equals(gs)) {
			if (b.getPlayerToMove().equals(Color.WHITE)) {
				logger.info("RESULT 0-1 {Black mates}\n");
			} else {
				logger.info("RESULT 1-0 {White mates}\n");
			}
		} else if (GameStatus.STALEMATED.equals(gs)) {
			logger.info("RESULT 1/2-1/2 {Stalemate}\n");
		} else if (GameStatus.DRAW_MATERIAL.equals(gs)) {
			logger.info("RESULT 1/2-1/2 {Draw by lack of mating material}\n");
		} else if (GameStatus.DRAW_BY_50.equals(gs)) {
			logger.info("RESULT 1/2-1/2 {Draw by 50 move rule}\n");
		} else if (GameStatus.DRAW_REP.equals(gs)) {
			logger.info("RESULT 1/2-1/2 {Draw by repetition}\n");
		}
	}
}
