package chess4j;

import java.text.ParseException;

import junit.framework.Assert;


import org.junit.Test;

import chess4j.board.Board;
import chess4j.io.FenParser;
import chess4j.utils.Perft;

public class PerfTest {

	@Test 
	public void perfTest1() throws ParseException {
		String fen="rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR w KQkq -";
		FenParser.setPos(Board.INSTANCE, fen);
		long n = Perft.perft(Board.INSTANCE,6);
		Assert.assertEquals(124132537,n);
	}
	
	@Test 
	public void perfTest2() throws ParseException {
		String fen="r3k2r/p1ppqpb1/bn2pnp1/3PN3/1p2P3/2N2Q1p/PPPBBPPP/R3K2R w KQkq -";
		FenParser.setPos(Board.INSTANCE, fen);			
		long n = Perft.perft(Board.INSTANCE,5);
		Assert.assertEquals(197876243,n);
	}
}
