package chess4j.utils;

import java.util.ArrayList;
import java.util.List;

import junit.framework.Assert;

import org.junit.Test;

import chess4j.board.File;
import chess4j.board.Rank;
import chess4j.board.Square;
import chess4j.moves.Move;

public class MoveUtilsTest {

	@Test
	public void testMoveToTop() {
		Move m1 = new Move(Square.valueOf(File.FILE_E, Rank.RANK_2),Square.valueOf(File.FILE_E, Rank.RANK_3));
		Move m2 = new Move(Square.valueOf(File.FILE_E, Rank.RANK_2),Square.valueOf(File.FILE_E, Rank.RANK_4));
		Move m3 = new Move(Square.valueOf(File.FILE_A, Rank.RANK_2),Square.valueOf(File.FILE_A, Rank.RANK_3));
		Move m4 = new Move(Square.valueOf(File.FILE_G, Rank.RANK_1),Square.valueOf(File.FILE_F, Rank.RANK_3));
		
		List<Move> moves = new ArrayList<Move>();
		moves.add(m1);
		moves.add(m2);
		moves.add(m3);
		moves.add(m4);
		
		Assert.assertEquals(m1, moves.get(0));
		MoveUtils.putMoveAtTop(moves, m3);
		Assert.assertEquals(4, moves.size());
		Assert.assertEquals(m3, moves.get(0));
		Assert.assertEquals(m1, moves.get(1));
		Assert.assertEquals(m2, moves.get(2));
		Assert.assertEquals(m4, moves.get(3));
		
	}
}
